/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package javafxapplication1;

import javafx.scene.Scene;
import javafx.scene.layout.Stack;
import javafx.scene.layout.VBox;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.TextBox;
import javafx.scene.control.ToggleGroup;
import javafx.scene.control.RadioButton;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.Separator;
import javafx.scene.layout.HBox;
import javafx.scene.control.Button;
import javafx.geometry.VPos;
import javafx.scene.layout.LayoutInfo;
import javafx.scene.control.ProgressBar;
import javafx.animation.Timeline;
import javafx.geometry.HPos;
import javafx.geometry.Insets;
import javafx.stage.Stage;
import javafx.fxd.FXDNode;
import javafx.fxd.FXDLoader;
import javafx.scene.text.Text;
import javafx.scene.image.ImageView;
import javafx.scene.transform.Scale;
import javafx.scene.control.ScrollView;
import javafx.scene.Node;
import javafx.scene.input.MouseEvent;

//drei Forms als Container der verschiedenen Views
var form1: HBox;
var form2: VBox;
var form3: VBox;

//ChoiceBox zur Auswahl der Pizzagröße
var pizzaSize: ChoiceBox;

//TextBox zur Eingabe der PizzaAnzahl
var pizzaAnzahl: TextBox;

//Boden-Auswahl
var pizzaBoden: ChoiceBox;
var pizzaCheesyCrustGroup = ToggleGroup {}; // a toggle group for the radio buttons
var pizzaMitCheesyCrust: RadioButton;
var pizzaOhneCheesyCrust: RadioButton;

//Pizza-Extras
var chillis: CheckBox on replace oldValue{
    if(chillis.selected){
        pizzaObject.chillis.visible = true;
    }
    else{
        pizzaObject.chillis.visible = false;
    }
};
var salami: CheckBox on replace oldValue{
    if(salami.selected){
        pizzaObject.salami.visible = true;
    }
    else{
        pizzaObject.salami.visible = false;
    }
};
var pilze: CheckBox on replace oldValue{
    if(pilze.selected){
        pizzaObject.pilze.visible = true;
    }
    else{
        pizzaObject.pilze.visible = false;
    }
};

def pizzaObject = pizzaUI{};

form1 = HBox{
        spacing: 10
        content:[
            VBox {
                content: [
                Label {text: "Online Pizza Bestellung" styleClass: "title"},
                Separator {},
                HBox {
                    spacing: 20
                    nodeVPos: VPos.BASELINE
                    content: [
                        Label {text: "Pizza-Größe:" },
                        pizzaSize = ChoiceBox {
                            items: ["Small ca. 24 cm", "Medium ca. 32 cm", "Large ca. 38 cm"] ,
                            //layoutInfo: LayoutInfo {width: 100 }
                        },
                     ]
                },
                Separator {},
                HBox {
                    spacing: 5
                    nodeVPos: VPos.BASELINE
                    content: [
                        Label {text: "Anzahl:" },
                        pizzaAnzahl = TextBox {
                            text: "1",
                        },
                    ]
                },
                HBox {
                    spacing: 10
                    nodeVPos: VPos.BASELINE
                    content: [
                        Label {text: "Boden:" },
                        pizzaBoden = ChoiceBox {
                            items: ["Italian", "American", "Vollkorn"]
                        },
                        pizzaMitCheesyCrust = RadioButton {
                            toggleGroup: pizzaCheesyCrustGroup
                            text: "mit CheesyCrust"
                            value: "mit CheesyCrust"
                        },
                        pizzaOhneCheesyCrust = RadioButton {
                            toggleGroup: pizzaCheesyCrustGroup
                            text: "ohne CheesyCrust"
                            value: "ohne CheesyCrust"
                            selected: true
                        }
                    ]
                },
                Separator {},
                HBox {
                    spacing: 35
                    content: [
                        salami = CheckBox {
                            text: "Salami",
                            onMouseClicked:
                            function(e: MouseEvent) {
                                if(salami.selected){
                                    pizzaObject.salami.visible = true;
                                }
                                else{
                                    pizzaObject.salami.visible = false;
                                }
                            };
                        }

                        pilze = CheckBox {
                            text: "Pilze",
                            onMouseClicked:
                            function(e: MouseEvent) {
                                if(pilze.selected){
                                    pizzaObject.pilze.visible = true;
                                }
                                else{
                                    pizzaObject.pilze.visible = false;
                                }
                            };
                        },
                        chillis = CheckBox {
                            text: "Chillis",
                            onMouseClicked:
                            function(e: MouseEvent) {
                                if(chillis.selected){
                                    pizzaObject.chillis.visible = true;
                                }
                                else{
                                    pizzaObject.chillis.visible = false;
                                }
                            };
                        },
                    ]
                },

                Separator {},
                Button {
                    text: "Bestellen"
                    action: function () {
                        form1.visible = false;
                        t.play();
                    }
                }
    ]
    },
            VBox{
                spacing: 20
                content:[
                      pizzaObject
                ]
            }
        ]
    };

def progressBar = ProgressBar {};
form2 = VBox {
    spacing: 10
    nodeHPos: HPos.CENTER
    vpos: VPos.CENTER
    visible: bind t.running
    content: [
        Label {text: "Bitte warten, bis die Bestellung abgeschlossen ist." },
        progressBar
    ]
};

var t = Timeline {
    keyFrames: [
        at (0s) {progressBar.progress => 0.0},
        at (5s) {progressBar.progress => 1.0}
    ]
}

form3 = VBox {
    visible: bind (progressBar.progress == 1.0)
    spacing: 5
    vpos: VPos.CENTER
    content: [
        Label {text: "Überblick über Ihre Bestellung" styleClass: "title"},
        Separator {},
        Label {text: bind "Pizza-Größe: {pizzaSize.selectedItem}"},
        Label{text: bind "Sie möchten {pizzaAnzahl.text} Pizza(s)."},
        Label{text: "Sie wählten folgende Zutaten für die Pizza:"},

        Label {text: bind if (pilze.selected) "Pilze" else ""},
        Label {text: bind if (chillis.selected) "Chillis" else ""},
        Label {text: bind if (salami.selected) "Salami" else ""},
        Separator{},
        Label {text: "Vielen Dank!" styleClass: "thanks"}
    ]
};


Stage {
    title: "Pizza Bestellung"
    scene : Scene {
//        width: width, height: height,
        //fill: Color.BLACK
        stylesheets: "{__DIR__}bookingStyle.css";
        content: [
            Stack {
//                layoutInfo: LayoutInfo{width: scene.width}
                padding: Insets {top: 5 bottom: 5 left: 5 right: 5}
                content: [
                    form1,
                    form2,
                    form3
                ]
            }
        ]
    }
}

