/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pizzabestellung;

import javafx.beans.value.ObservableValue;
import javafx.collections.FXCollections;
import javafx.scene.Group;
import javafx.scene.control.Button;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.control.CheckBox;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.Separator;
import javafx.scene.control.TextBox;
import javafx.scene.control.ToggleGroup;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.Stage;
import java.io.File;
import javafx.beans.value.ChangeListener;
import javafx.geometry.Pos;
import javafx.scene.control.Toggle;
import javafx.scene.input.MouseEvent;
/**
 *
 * @author janus
 */
public class StartBildschirm extends Group {
    Button btn = new Button();
    HBox pane = new HBox();
    VBox controls = new VBox();
    VBox image = new VBox();
    Stage mainStage = new Stage();
    TextBox pizzaAnzahl = new TextBox();
    Bestellung bestellung = new Bestellung();
    
    final ToggleGroup cheesyCrustGroup = new ToggleGroup();
    
    public StartBildschirm(Stage primaryStage){
        mainStage = primaryStage;
        pane.setSpacing(10);
        pane.getChildren().addAll(controls = createControlBox(), image = createImageBox());
        this.getChildren().add(pane);
    }
    
    private Button createButton(String buttonText, int posX, int posY){
        btn.setLayoutX(posX);
        btn.setLayoutY(posY);
        btn.setText(buttonText);
        btn.setOnAction(new EventHandler<ActionEvent>() {

            public void handle(ActionEvent event) {
                Scene scene = new Scene(new LadeBildschirm(mainStage, bestellung), 500, 250);
                scene.getStylesheets().add("bookingStyle.css");
                bestellung.setAnzahl(Integer.parseInt(pizzaAnzahl.getText()));
                mainStage.setScene(scene);
                
            }
        });
        return btn;
    }

    private VBox createControlBox() {
        Label title = new Label("Online Pizza Bestellung");
        title.getStyleClass().add("title");
        
        Separator space = new Separator();
        
        HBox pizzaGrößen = new HBox();
        pizzaGrößen.setSpacing(20);
        final ChoiceBox pizzaSizes = new ChoiceBox(FXCollections.observableArrayList("Small ca. 24 cm", "Medium ca. 32 cm", "Large ca. 38 cm"));
        pizzaSizes.getSelectionModel().selectedIndexProperty().addListener(new ChangeListener<Number>(){

            public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
//                bestellung.setSize(pizzaSizes.getSelectionModel().getSelectedItem());
                bestellung.setSize(pizzaSizes.getItems().get(newValue.intValue()));
            }
            
        }
        );
        pizzaGrößen.getChildren().addAll(new Label("Pizza-Größen"), pizzaSizes);
        
        Separator space1 = new Separator();
        
        HBox pizzaSumme = new HBox();
        pizzaSumme.setSpacing(20);
        pizzaAnzahl = new TextBox("1");
        pizzaSumme.getChildren().addAll(new Label("Anzahl: "), pizzaAnzahl);
        HBox pizzaBodenAuswahl = new HBox();
        final ChoiceBox pizzaBoden = new ChoiceBox(FXCollections.observableArrayList("Italian", "American", "Vollkorn"));
        
        pizzaBoden.getSelectionModel().selectedIndexProperty().addListener(new ChangeListener<Number>(){

            public void changed(ObservableValue<? extends Number> observable, Number oldValue, Number newValue) {
                bestellung.setBoden(pizzaBoden.getItems().get(newValue.intValue()));
            }
            
        });
        
        pizzaBodenAuswahl.setSpacing(20);
        RadioButton pizzaMitCheesyCrust = new RadioButton("mit CheesyCrust");
        pizzaMitCheesyCrust.setUserData("mit CheesyCrust");
        pizzaMitCheesyCrust.setToggleGroup(cheesyCrustGroup);
        RadioButton pizzaOhneCheesyCrust = new RadioButton("ohne CheesyCrust");
        pizzaOhneCheesyCrust.setUserData("ohne CheesyCrust");
        pizzaOhneCheesyCrust.setToggleGroup(cheesyCrustGroup);
        pizzaOhneCheesyCrust.setSelected(true);
        
        cheesyCrustGroup.selectedToggleProperty().addListener(new ChangeListener<Toggle>(){
            public void changed(ObservableValue<? extends Toggle> ov, Toggle old_toggle, Toggle new_toggle) {
                    if (cheesyCrustGroup.getSelectedToggle() != null) {
                        if(cheesyCrustGroup.getSelectedToggle().getUserData()== "mit CheesyCrust"){
                            bestellung.setCheesycrust(true);
                        }
                        else if(cheesyCrustGroup.getSelectedToggle().getUserData()== "ohne CheesyCrust"){
                            bestellung.setCheesycrust(false);
                        }
                    }                
                }
        });
        
        pizzaBodenAuswahl.getChildren().addAll(new Label("Boden: "), pizzaBoden, pizzaMitCheesyCrust, pizzaOhneCheesyCrust);
        
        Separator space2 = new Separator();
        
        HBox pizzaItems = new HBox();
        pizzaItems.setSpacing(35);
        
        CheckBox salami = new CheckBox("Salami");
        
        salami.selectedProperty().addListener(new ChangeListener<Boolean>() {
            public void changed(ObservableValue<? extends Boolean> ov, Boolean old_val, Boolean new_val) {
                    if(new_val){
                        bestellung.setSalami(true);
                    }
                    else{
                        bestellung.setSalami(false);
                    }
            }
        });
        
        CheckBox pilze = new CheckBox("Pilze");
        
        pilze.selectedProperty().addListener(new ChangeListener<Boolean>() {
            public void changed(ObservableValue<? extends Boolean> ov, Boolean old_val, Boolean new_val) {
                    if(new_val){
                        bestellung.setPilze(true);
                    }
                    else{
                        bestellung.setPilze(false);
                    }
            }
        });
        
        CheckBox chillis = new CheckBox("Chillis");
        
        chillis.selectedProperty().addListener(new ChangeListener<Boolean>() {
            public void changed(ObservableValue<? extends Boolean> ov, Boolean old_val, Boolean new_val) {
                    if(new_val){
                        bestellung.setChillis(true);
                    }
                    else{
                        bestellung.setChillis(false);
                    }
            }
        });
        
        pizzaItems.getChildren().addAll(salami, pilze, chillis);
        
        Separator space3 = new Separator();
        controls.setSpacing(5);
        controls.getChildren().addAll(title,space,pizzaGrößen, space1, pizzaSumme, pizzaBodenAuswahl, space2, pizzaItems, space3, btn = createButton("Bestellen", 100, 200)); //vielliecht ein Space ausreichend?
        return controls;
    }
    
    private VBox createImageBox() {
        Image pizzaImage = new Image("pizza.jpg", 150, 150, true, true);
        ImageView pizzaView = new ImageView();
        pizzaView.setImage(pizzaImage);
        image.getChildren().add(pizzaView);
        image.setAlignment(Pos.CENTER);
        return image;
    }
}